package cn.buaa.myweixin;

import android.content.Context;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.util.Log;

/**
 * һֻҡεļ
 */
public class ShakeListener implements SensorEventListener {
	// ٶֵҡٶȴﵽֵ
	private static final int SPEED_SHRESHOLD = 3000;
	// μʱ
	private static final int UPTATE_INTERVAL_TIME = 70;
	// 
	private SensorManager sensorManager;
	// 
	private Sensor sensor;
	// Ӧ
	private OnShakeListener onShakeListener;
	// 
	private Context mContext;
	// ֻһλʱӦ
	private float lastX;
	private float lastY;
	private float lastZ;
	// ϴμʱ
	private long lastUpdateTime;

	// 
	public ShakeListener(Context c) {
		// ü
		mContext = c;
		start();
	}

	// ʼ
	public void start() {
		// ô
		sensorManager = (SensorManager) mContext
				.getSystemService(Context.SENSOR_SERVICE);
		if (sensorManager != null) {
			// 
			sensor = sensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);
		}
		// ע
		if (sensor != null) {
			sensorManager.registerListener(this, sensor,
					SensorManager.SENSOR_DELAY_GAME);
		}

	}

	// ֹͣ
	public void stop() {
		sensorManager.unregisterListener(this);
	}

	// Ӧ
	public void setOnShakeListener(OnShakeListener listener) {
		onShakeListener = listener;
	}

	// ӦӦñ仯
	public void onSensorChanged(SensorEvent event) {
		// ڼʱ
		long currentUpdateTime = System.currentTimeMillis();
		// μʱ
		long timeInterval = currentUpdateTime - lastUpdateTime;
		// жǷﵽ˼ʱ
		if (timeInterval < UPTATE_INTERVAL_TIME)
			return;
		// ڵʱlastʱ
		lastUpdateTime = currentUpdateTime;

		// x,y,z
		float x = event.values[0];
		float y = event.values[1];
		float z = event.values[2];

		// x,y,zı仯ֵ
		float deltaX = x - lastX;
		float deltaY = y - lastY;
		float deltaZ = z - lastZ;

		// ڵlast
		lastX = x;
		lastY = y;
		lastZ = z;

		double speed = Math.sqrt(deltaX * deltaX + deltaY * deltaY + deltaZ
				* deltaZ)
				/ timeInterval * 10000;
		Log.v("thelog", "===========log===================");
		// ﵽٶȷֵʾ
		if (speed >= SPEED_SHRESHOLD) {
			onShakeListener.onShake();
		}
	}

	public void onAccuracyChanged(Sensor sensor, int accuracy) {

	}

	// ҡμӿ
	public interface OnShakeListener {
		public void onShake();
	}

}